unit UFrmPrincipal;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, Forms, Controls, Graphics, Dialogs, StdCtrls, ExtCtrls,
  Menus;

type

  { TFrmPrincipal }

  TFrmPrincipal = class(TForm)
    btnCalcul: TButton;
    edKm: TEdit;
    edJour: TEdit;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    lblPrix: TLabel;
    MainMenu1: TMainMenu;
    MenuItem1: TMenuItem;
    MenuItem2: TMenuItem;
    MenuItem3: TMenuItem;
    MenuItem4: TMenuItem;
    MenuItem5: TMenuItem;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    Separator2: TMenuItem;
    Separator1: TMenuItem;
    rgCode: TRadioGroup;
    procedure btnCalculClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure FormShow(Sender: TObject);
    procedure MenuItem2Click(Sender: TObject);
    procedure MenuItem3Click(Sender: TObject);
    procedure MenuItem4Click(Sender: TObject);
    procedure MenuItem5Click(Sender: TObject);
  private

  public

  end;

var
  FrmPrincipal: TFrmPrincipal;

implementation

{$R *.lfm}

{ TFrmPrincipal }

procedure TFrmPrincipal.btnCalculClick(Sender: TObject);
var jour, km: integer;
    ok: boolean;
    prix: double;
begin
  //récupération jour
  ok:= Sysutils.TryStrToInt(self.edJour.Text,jour);
  //récupération km
  ok:= ok and Sysutils.TryStrToInt(self.edKm.Text,km);
  //ok pour les saisies ?
  if (ok = True)
   then
    begin
     //selon le type de véhicule
     case self.rgCode.ItemIndex of
       0: prix:= 11.0 * jour;
       1: prix:= 10.0 * jour + 0.3 * km;
       2: prix:= 6.0 * jour + 0.5 * km;
       3: prix:= 5.0 * jour + 1.0 * km;
     end;
     //affichage
     self.lblPrix.Caption:= FloatToStr(prix);
    end
   else Dialogs.MessageDlg('Erreur','Problème saisies',mtError,[mbOk],0);
end;

procedure TFrmPrincipal.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if (Dialogs.MessageDlg('Fermeture','Fermer l''application',mtConfirmation,[mbYes,mbNo],0) = mrYes)
   then CanClose:= True
   else CanClose:= False;
end;

procedure TFrmPrincipal.FormShow(Sender: TObject);
var prenom: string;
begin
  prenom:= Dialogs.InputBox('Bonjour','Entrez votre prénom','Toto');
  self.Caption:= 'Bonjour ' + prenom;
end;

procedure TFrmPrincipal.MenuItem2Click(Sender: TObject);
begin
  //raz des editbox
  self.edJour.Text:= '0';
  self.edKm.Text:= '0';
end;

procedure TFrmPrincipal.MenuItem3Click(Sender: TObject);
var F: TextFile;
    s: string;
    p: integer;
begin
  if (self.OpenDialog.Execute() = True)
   then
    begin
     AssignFile(F,self.OpenDialog.FileName);
     Reset(F);
     if not(eof(F))
      then
       begin
        readln(F,s);
        p:= pos(';',s);
        if (p > 0)
         then
          begin
           self.edJour.Text:= copy(s,1,p-1);
           self.edKm.Text:= copy(s,p+1,length(s));
          end
         else MessageDlg('Lecture fichier','Données non conformes',mtError,[mbOk],0);
       end;
     CloseFile(F);
    end;
end;

procedure TFrmPrincipal.MenuItem4Click(Sender: TObject);
var F: TextFile;
    s: string;
begin
  if (self.SaveDialog.Execute() = True)
   then
    begin
     AssignFile(F,self.SaveDialog.FileName);
     rewrite(F);
     s:= self.edJour.Text + ';' + self.edKm.Text;//former la chaîne à sauvegarder
     writeln(F,s);//écrire dans le fichier
     closefile(F);
    end;
end;

procedure TFrmPrincipal.MenuItem5Click(Sender: TObject);
begin
  self.close();
end;

end.

